import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.nio.charset.*;
import java.nio.file.*;
import java.util.*;
import javax.imageio.*;
import javax.swing.*;

//-------------------------------------
class BioRhythm extends JFrame {

static BioRhythm mf;

CDA     cnvs;
JButton sbar;

//-------------------------------------
ArrayList<Point> eda, ida, pda;
BufferedImage    img;
Font             uif;
int              cnvx, cnvy, maxx, maxy, winx, winy, wxp, wyp;
int              uifs;
int              bday, bmon, byer, cday, cmon, cyer, totday;
String           stxt, uifn;

int nday[]= {00, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

//-------------------------------------
static final int    NDIV    = 31;
static final int    UIFS    = 32;
static final int    WXP     = 80;
static final int    WYP     = 60;
static final String BDAYLIT = "BDAY";
static final String BMONLIT = "BMON";
static final String BYERLIT = "BYER";
static final String UIFN    = "Sans";
static final String UIFNLIT = "UIFN";
static final String UIFSLIT = "UIFS";
static final String WXPLIT  = "WXP";
static final String WYPLIT  = "WYP";

//-------------------------------------
class ABirthdate implements ActionListener {
public void actionPerformed(ActionEvent qae) {
int nd, nm, ny;
  nd = Util.GetIntValue("New Birth Day", bday, mf);
  if (nd==-1) return;
  nm = Util.GetIntValue("New Birth Month", bmon, mf);
  if (nm==-1) return;
  ny = Util.GetIntValue("New Birth Year", byer, mf);
  if (ny==-1) return;
  bday = nd;
  bmon = nm;
  byer = ny;
  RenderPlot();
}}

//-------------------------------------
class ACheckdate implements ActionListener {
public void actionPerformed(ActionEvent qae) {
int nd, nm, ny;
  nd = Util.GetIntValue("New Check Day", cday, mf);
  if (nd==-1) return;
  nm = Util.GetIntValue("New Check Month", cmon, mf);
  if (nm==-1) return;
  ny = Util.GetIntValue("New Check Year", cyer, mf);
  if (ny==-1) return;
  cday = nd;
  cmon = nm;
  cyer = ny;
  RenderPlot();
}}

//-------------------------------------
class AMinimize implements ActionListener {
public void actionPerformed(ActionEvent qae) {
  mf.setState(Frame.ICONIFIED);
}}

//-------------------------------------
public void AppQuit() {
  System.exit(0);
}

//-------------------------------------
class AQuit implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  AppQuit();
}}

//-------------------------------------
public BioRhythm(String[] args) {
Dimension dim;
Toolkit   tk;
  tk = Toolkit.getDefaultToolkit();
  dim = tk.getScreenSize();
  maxx = dim.width;
  maxy = dim.height;
}

//---------------------------------------------
void CalcCycles() {
int      amp, mid, off;
  off = uifs*2;
  mid = ((cnvy-off)/2)+off;
  amp = mid-off;
  CalcTotal();
  FillPoints(pda, totday, 23, mid, amp);
  FillPoints(eda, totday, 28, mid, amp);
  FillPoints(ida, totday, 33, mid, amp);
}

//---------------------------------------------
void CalcTotal() {
Calendar bd, cd;
long     bm, cm, delta;
String   s;
  bd = new Calendar.Builder().setDate(byer, bmon, bday).build();
  cd = new Calendar.Builder().setDate(cyer, cmon, 1).build();
  bm = bd.getTimeInMillis();
  cm = cd.getTimeInMillis();
  delta = cm - bm;
  delta /= 1000;
  delta /= 60;
  delta /= 60;
  delta /= 24;
  totday = (int)delta;
  s = String.format("Birthdate %d/%d/%d ", byer, bmon, bday);
  s += String.format("Checkdate %d/%d/%d ", cyer, cmon, cday);
  s += String.format("Days alive = %d", totday+cday-1);
  sbar.setText(s);
}

//-------------------------------------
class CBButton implements ActionListener {
public void actionPerformed(ActionEvent ae) {
  PopupMain();
}}

//-------------------------------------
class CBKey extends KeyAdapter {
public void keyPressed(KeyEvent ke) {
  if (ke.getKeyCode() == KeyEvent.VK_F1) PopupMain();
  if (ke.getKeyCode() == KeyEvent.VK_Q) AppQuit();
}}

//-------------------------------------
class CBResize extends ComponentAdapter {
public void componentResized(ComponentEvent ce) {
  cnvy = cnvs.getHeight();
  cnvx = cnvs.getWidth();
  img = new BufferedImage(cnvx, cnvy, BufferedImage.TYPE_INT_RGB);
}}

//---------------------------------------------
void FillPoints(ArrayList<Point> pa, int td, int period, int mid, int scale) {
int     i, ndtm, xsiz;
long    x, y;
double  num, div;
  pa.clear();
  ndtm = nday[cmon];
  xsiz = cnvx/ndtm;
  for (i=0; i<=ndtm; i++) {
    x = i*xsiz;
    num = (((td+i)%period)-0.5)*2.0*Math.PI;
    div = period;
    y = (long)(mid-(scale*Math.sin(num/div)));
    pa.add(new Point((int)x, (int)y));
 }
}

//-------------------------------------
public void Initlz() {
java.util.Timer tmr;
  InitlzData();
  ReadIniFile();
  InitlzUI();
  LayoutUI();
  tmr = new java.util.Timer();
  tmr.schedule(new RunRender(), 100);
}

//-------------------------------------
public void InitlzData() {
Calendar today;
  uifs = UIFS;
  uifn = UIFN;
  wxp = WXP;
  wyp = WYP;
  stxt = "Click Here";
  bday = 19;
  bmon = 3;
  byer = 1955;
  today = Calendar.getInstance();
  cday = today.get(Calendar.DAY_OF_MONTH);
  cmon = today.get(Calendar.MONTH)+1;
  cyer = today.get(Calendar.YEAR);
  eda = new ArrayList<Point>();
  ida = new ArrayList<Point>();
  pda = new ArrayList<Point>();
}

//-------------------------------------
public void InitlzUI() {
  winx = (maxx*wxp)/100;
  winy = (maxy*wyp)/100;
  uif = new Font(uifn, Font.BOLD, uifs);
  Util.PutUIManFonts(uif);
  cnvs = new CDA();
  cnvs.setBackground(new Color(200, 200, 200));
  cnvs.addKeyListener(new CBKey());
  cnvs.addComponentListener(new CBResize());
  sbar = new JButton(stxt);
  sbar.setFont(uif);
  sbar.addActionListener(new CBButton());
  sbar.setBackground(new Color(16, 16, 128));
  sbar.setForeground(new Color(255, 255, 0));
}

//---------------------------------------------
boolean IsLeap(int year) {
boolean rval;
int     cy;
  rval = false;
  cy = year;
  if (((cy/100)*100)==cy) {
    if (((cy/400)*400)==cy) rval = true;
  } else if (((cy/4)*4)==cy) rval = true;
  return(rval);
}

//-------------------------------------
public void LayoutUI() {
Image     iimg;
Toolkit   tk;
URL       iurl;
  mf.addKeyListener(new CBKey());
  mf.setSize(winx, winy);
  mf.getContentPane().add(sbar, BorderLayout.NORTH);
  mf.getContentPane().add(cnvs, BorderLayout.CENTER);
  mf.setTitle("BioRhythm");
  mf.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
  mf.setVisible(true);
  iurl = this.getClass().getResource("/BioRhythm.png");
  tk = Toolkit.getDefaultToolkit();
  iimg = tk.createImage(iurl);
  mf.setIconImage(iimg);
}

//-------------------------------------
public static void main(String[] args) {
  System.out.println("starting BioRhythm\n");
  mf = new BioRhythm(args);
  mf.Initlz();
}

//-------------------------------------
public void PopupMain() {
JMenuItem     mi;
JPopupMenu    pum;
  pum = new JPopupMenu();
  mi = new JMenuItem("Birthdate");
  mi.setMnemonic('B');
  mi.addActionListener(new ABirthdate());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Checkdate");
  mi.setMnemonic('C');
  mi.addActionListener(new ACheckdate());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Minimize");
  mi.setMnemonic('M');
  mi.addActionListener(new AMinimize());
  mi.setFont(uif);
  pum.add(mi);
  mi = new JMenuItem("Quit");
  mi.setMnemonic('Q');
  mi.addActionListener(new AQuit());
  mi.setFont(uif);
  pum.add(mi);
  pum.show(sbar, 0, 0);
}

//-------------------------------------
public void ReadIniFile() {
BufferedReader  br;
Charset         cs;
File            inif;
Path            ifp;
String          jini, line, nam, val;
String[]        sa;
  jini = System.getenv("JINI")+"BioRhythm.ini";
  inif = new File(jini);
  if (!inif.exists()) {
    stxt = "no ini file";
    return;
  }
  ifp = inif.toPath();
  cs = Charset.forName("US-ASCII");
  try {
    br = Files.newBufferedReader(ifp, cs);
    while ((line = br.readLine()) != null) {
      sa = line.split("=");
      if (sa.length==2) {
        nam = sa[0];
        val = sa[1];
        if (nam.compareTo(UIFNLIT)==0) uifn = val;
        if (nam.compareTo(UIFSLIT)==0) uifs = Integer.parseInt(val);
        if (nam.compareTo(WXPLIT)==0) wxp = Integer.parseInt(val);
        if (nam.compareTo(WYPLIT)==0) wyp = Integer.parseInt(val);
        if (nam.compareTo(BDAYLIT)==0) bday = Integer.parseInt(val);
        if (nam.compareTo(BMONLIT)==0) bmon = Integer.parseInt(val);
        if (nam.compareTo(BYERLIT)==0) byer = Integer.parseInt(val);
      }
    }
  } catch (Exception x) { System.err.format("Exception: %s%n", x); }
}

//-------------------------------------
public void RenderPlot() {
Graphics     g;
Graphics2D   g2;
  CalcTotal();
  CalcCycles();
  g = img.getGraphics();
  g.setColor(new Color(1.0f, 1.0f, 1.0f, 1.0f));
  g.fillRect(0, 0, cnvx, cnvy); 
  g2 = (Graphics2D)g;
  g2.setStroke(new BasicStroke(4));
  ShowDays(g);
  ShowPlots(g);
  g.dispose();
  cnvs.img = img;
  cnvs.repaint(new Rectangle(cnvx, cnvy));
}

//-------------------------------------
void RenderPoints(Graphics g, ArrayList<Point> pa) {
int   bx, by, i, ne;
Point p;
  ne = pa.size();
  p = pa.get(0);
  bx = p.x;
  by = p.y;
  for (i=1; i<ne; i++) {
    p = pa.get(i);
    g.drawLine(bx, by, p.x, p.y);
    bx = p.x;
    by = p.y;
  }
}

//-------------------------------------
void RenderTextCentered(Graphics g, String s, Rectangle r, Font f) {
FontMetrics fm;
int         x, y;
  fm = g.getFontMetrics(f);
  x = r.x+(r.width-fm.stringWidth(s))/2;
  y = r.y+((r.height-fm.getHeight())/2)+fm.getAscent();
  g.setFont(f);
  g.drawString(s, x, y);
}

//-------------------------------------
class RunRender extends TimerTask {
public void run() {
  RenderPlot();
}}

//---------------------------------------------
void ShowDays(Graphics g) {
int       amp, i, mid, ndtm, off, xday, xinc;
Rectangle r;
String    s;
  off = uifs*2;
  mid = ((cnvy-off)/2)+off;
  amp = mid-off;
  ndtm = nday[cmon];
  xinc = cnvx/ndtm;
  xday = xinc*(cday-1);
  g.setColor(new Color(0.0f, 0.0f, 0.0f, 1.0f));
  for (i=0; i<ndtm; i++) {
    s = String.format("%d", (i+1)%10);
    r = new Rectangle(i*xinc, 0, xinc, off);
    RenderTextCentered(g, s, r, uif);
  } 
  g.drawLine(0, mid, cnvx, mid);
  g.drawLine(xday, 0, xday, cnvy);
  xday += xinc;
  g.drawLine(xday, 0, xday, cnvy);
}

//---------------------------------------------
void ShowPlots(Graphics g) {
  g.setColor(new Color(1.0f, 0.0f, 0.0f, 1.0f));
  RenderPoints(g, pda);
  g.setColor(new Color(0.0f, 0.0f, 1.0f, 1.0f));
  RenderPoints(g, eda);
  g.setColor(new Color(0.0f, 1.0f, 0.0f, 1.0f));
  RenderPoints(g, ida);
}

//-------------------------------------
}
